;
; HSP3.0 Utility macros and functions
;
#ifndef __hsp3util__
#define __hsp3util__

#module "hsp3util"

#define WS_VISIBLE 0x10000000 
#define WS_CHILD 0x40000000 

#define PBM_SETSTEP	1028
#define PBM_STEPIT	1029

#define SBM_SETPOS 224
#define SBM_GETPOS 225
#define SBM_SETRANGE 226
#define SBM_SETRANGEREDRAW 230

;--------------------------------------------------------------------------------

#deffunc bmppalette str _fname

	;	8bitBMPt@C̃pbgo
	;	bmppalette "BMPt@C"
	;
	exist _fname :if strsize<1078 :return
	dim a,270 : bload _fname,a,1078			;BMPwb_[ǂݏo

	if peek(a,$1c)>8	:return			;8bitBMPłȂreturn
	if wpeek(a,0)!$4d42	:return			;"BM"`FbNFI͔
	cols=lpeek(a,$2e)	:if cols=0:cols=256	;FFcols=0 256F

	i=$36
	repeat cols
		palette cnt,peek(a,i+2),peek(a,i+1),peek(a,i)
		i+=4
	loop
	dim a,0
	return

#deffunc gettimestr var _p1

	;	"hh:mm:ss"̌`Ŏ𓾂ĕϐɑ
	;	gettimestr ϐ
	;
	_p1 = strf("%02d",gettime(4))+":"+strf("%02d",gettime(5))+":"+strf("%02d",gettime(6))
	return

#deffunc getdatestr var _p1

	;	"yyyy/mm/dd"̌`œt𓾂ĕϐɑ
	;	getdatestr ϐ
	;
	_p1 = strf("%02d",gettime(0))+"/"+strf("%02d",gettime(1))+"/"+strf("%02d",gettime(3))
	return

;--------------------------------------------------------------------------------

#deffunc text int _p1

	;	emes߂ŕ\镶̑҂Ԃݒ肷
	;	text \҂(ms)
	;
	stwait=_p1
	return

#deffunc textmode int _p1, int _p2

	;	emes߂ŕ\镶̏Cݒ肷
	;	textmode [h, p[^[
	;		[h0 : ʏ̕\
	;		[h1 : et\
	;		[h2 : ֊st\
	;		([h1,2̏ꍇ͌ݐݒ肳ĂFKp܂)
	;		(p[^[ݒ肷Ɖe֊s̋C
	;		Ƃł܂)
	;
	stmode=_p1
	if stmode<=0 : return
	strval=ginfo_r
	stgval=ginfo_g
	stbval=ginfo_b
	stdiff=1+_p2
	return

#deffunc emes str _p1

	;	PÂƕ\
	;	(mes߂Ɠl̓)
	;	emes \eLXg
	;
	mesmax=strlen(_p1)
	if mesmax<=0 : return
	mestmp=_p1
	messg=""
	mescur=0
	a=0
	orgx=ginfo_cx
	if ( stmode ) {
		strval2=ginfo_r
		stgval2=ginfo_g
		stbval2=ginfo_b
	}

	if stwait<=0 {
		x=ginfo_cx:y=ginfo_cy
		messg=mestmp
		gosub *emes_aft
		return
	}

	repeat
		if mescur>=mesmax : break
		x=ginfo_cx:y=ginfo_cy
		a=peek(mestmp,mescur)
		mescur++
		if a<32 {
			if a=13 {
				if peek(mestmp,mescur)=10 : mescur++
				mes "":pos orgx
			}
			continue
		}
		poke messg,0,a
		poke messg,1,0
		if a>=128 {
			poke messg,1,peek(mestmp,mescur)
			poke messg,2,0
			mescur++
		}
		gosub *emes_aft
		pos x+ginfo_mesx,y
		await stwait
	loop

	mes "":pos orgx
	return

*emes_aft
	if stmode=0 {
		mes messg
		return
	}
	if stmode=1 {
		pos x+stdiff,y+stdiff
		color strval,stgval,stbval
		mes messg
		pos x,y
		color strval2,stgval2,stbval2
		mes messg
		return
	}
	if stmode=2 {
		color strval,stgval,stbval:
		pos x+stdiff,y:mes messg
		pos x-stdiff,y:mes messg
		pos x,y-stdiff:mes messg
		pos x,y+stdiff:mes messg
		pos x,y
		color strval2,stgval2,stbval2
		mes messg
		return
	}
	return


#deffunc gfade int _p1,int _p2,int _p3,int _p4,int _p5

	;
	;	ʂ̃tF[hsȂ
	;	(colorŐݒ肳ꂽFɃtF[h)
	;	gfade x, x,y,sx,sy
	;	x  = 0`256Ńxw肷
	;	(x,y)   = tF[hsȂ
	;	          (ȗ0,0)
	;	(sx,sy) = tF[hsȂTCY
	;	          (ȗ͉ʑS)
	;
	x=_p4:if x=0 : x=ginfo_winx
	y=_p5:if y=0 : y=ginfo_winy
	gmode 3,x,y,_p1
	x=_p2+(x/2):y=_p3+(y/2)
	grect x,y,0
	return


;--------------------------------------------------------------------------------

#deffunc statictext str _p1, int _p2, int _p3

	;
	;	X^eBbNeLXgzuIuWFNgƂĐ
	;	statictext "eLXg",XTCY,YTCY
	;	(posŎw肵ʒuɕ\܂)
	;
	winobj "STATIC",_p1,0,WS_VISIBLE|WS_CHILD,_p2,_p3
	id = stat
	return id

#deffunc statictext_set int _p1, str _p2

	;
	;	X^eBbNeLXg̓e
	;	statictext_set IuWFNgID,"eLXg"
	;
	sendmsg objinfo_hwnd(_p1),$c,0,_p2
	return stat

#deffunc scrollbar int _p1, int _p2

	;
	;	XN[o[zuIuWFNgƂĐ
	;	scrollbar XTCY,YTCY
	;	(posŎw肵ʒuɕ\܂)
	;
	winobj "SCROLLBAR","",0,WS_VISIBLE|WS_CHILD,_p1,_p2
	id = stat
	return id


#deffunc progbar int _p1, int _p2

	;
	;	vOXo[zuIuWFNgƂĐ
	;	progbar XTCY,YTCY
	;	(posŎw肵ʒuɕ\܂)
	;
	winobj "msctls_progress32","",0,WS_VISIBLE|WS_CHILD,_p1,_p2
	id = stat
	return id

#deffunc progbar_step int _p1

	;
	;	vOXo[1Xebvi߂
	;	progbar_step IuWFNgID
	;
	sendmsg objinfo_hwnd(_p1),PBM_STEPIT,0,0
	return

#deffunc progbar_set int _p1, int _p2

	;
	;	vOXo[̃Xebvݒ肷
	;	progbar_step IuWFNgID, 
	;
	sendmsg objinfo_hwnd(_p1),PBM_SETSTEP,_p2,0
	return

;--------------------------------------------------------------------------------

#deffunc note2array array _p1, str _p2

	;
	;	s̕sƂɔzϐɑ
	;	note2array ϐ,""
	;	(""Ŏw肵ezϐɕϊ܂)
	;	(z͂PzɂȂ܂)
	;
	mestmp = _p2
	notesel mestmp
	if notemax<=1 : _p1=_p2 : return
	sdim _p1,64,notemax
	repeat notemax
	noteget _p1.cnt, cnt
	loop
	sdim mestmp,64			; mestmpNA
	noteunsel
	return

#deffunc array2note var _p1, array _p2

	;
	;	^̔zϐ𕡐sƂĎ擾
	;	array2note ϐ1,ϐ2
	;	(ϐ2Ŏw肵P̔zϐϐ1(s)ɕϊ܂)
	;	(z͂Pẑ݂ɂȂ܂)
	;
	if length2(_p2)>0 : dialog "array2note:error" : return
	_p1 = ""
	foreach _p2
	_p1+=_p2.cnt+"\n"
	loop
	return

#deffunc arraysave str _p1, array _p2, local stmp

	;
	;	^̔zϐt@CɃZ[u
	;	arraysave "t@C",ϐ
	;	(sɕϊăZ[u܂)
	;	(z͂Pẑ݂ɂȂ܂)
	;
	array2note stmp, _p2
	notesel stmp
	notesave _p1
	noteunsel
	return

#deffunc arrayload str _p1, array _p2, local stmp

	;
	;	eLXgt@C𕶎^̔zϐɓǂݍ
	;	arrayload "t@C",ϐ
	;	(s̍szvfɕϊăZ[u܂)
	;	(z͂Pẑ݂ɂȂ܂)
	;
	notesel stmp
	noteload _p1
	noteunsel
	note2array _p2,stmp
	return


;--------------------------------------------------------------------------------

#global


#endif
